//  Copyright (c) 2019 AUTHORS
//
//  Distributed under the Boost Software License, Version 1.0. (See accompanying
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)


#ifndef ___NODE_REGISTRY_H
#define ___NODE_REGISTRY_H

#include "octotiger/defs.hpp"
#include "octotiger/node_server.hpp"

#include <unordered_map>

namespace node_registry {

struct hash {
	std::size_t operator()(const node_location& loc) const {
		return loc.hash();
	}
};


using node_ptr = node_client;
using table_type = std::unordered_map<node_location,node_ptr,hash>;
using iterator_type = table_type::iterator;

void add(const node_location&, node_ptr);

node_ptr get(const node_location& loc );

void delete_(const node_location&);

iterator_type begin();

iterator_type end();

const size_t size();

void clear();



}
#endif
